; Author: 			Faweyr
; Last Update:		23.2.2010
; Program:			Greeting Card
; Dont steal the source or the Bitmaps.


#include <GDIPlus.au3>
#include <WinAPI.au3>
#include <WindowsConstants.au3>
#include <GuiConstantsEx.au3>
#include <Memory.au3>
#NoTrayIcon
_GDIPlus_Startup()

FileInstall("gfx.dll",@TempDir & "\gfx.dll",1)

;###################################################################################################################
;Benutzerdefinierte Variablen:
$sString = "Hallo, na wie findest du die elektronische Grukarte? Es werden auch mehrere Bildschirme untersttzt!" & @lf &  "Sogar die Farbe der Messagebox ist dem Zufall berlassen. Du kannst auch die Dauer der Nachricht bestimmen."
$sTime = 7000	;ms	
;###################################################################################################################


;Destop-Mae:
$VirtualDesktopWidth = DLLCall("user32.dll", "int", "GetSystemMetrics", "int", 78)
$VirtualDesktopWidth = $VirtualDesktopWidth[0] - 140
$VirtualDesktopHeight = DLLCall("user32.dll", "int", "GetSystemMetrics", "int", 79)
$VirtualDesktopHeight = $VirtualDesktopHeight[0] - 140

;PNGs laden:
dim $bitmap[5][8]
for $l = 0 to 4 step 1
	for $i = 0 to 7 step 1
	$bitmap[$l][$i] = _ResourceLoadImage(@TempDir & "\gfx.dll", "spark_"&$l&"_" & $i)
	Next
Next
$full = _ResourceLoadImage(@TempDir & "\gfx.dll", "msg_" & Random(0,4,1))
$screen = _ResourceLoadImage(@TempDir & "\gfx.dll", "empty")
$trans = 255


#Region Main-Gui
	;Ladet eine leere Bitmap:

	$screen_context = _GDIPlus_ImageGetGraphicsContext($screen)
	
    $hBrush = _GDIPlus_BrushCreateSolid()				;Farbe
    $hFormat = _GDIPlus_StringFormatCreate()			;Format
    $hFamily = _GDIPlus_FontFamilyCreate("Times New Roman")		;Schriftart
    $hFont = _GDIPlus_FontCreate($hFamily, 16, 1)		;Schrift	(Schriftart ; Schriftgre ; Besonderheiten)
    $tLayout = _GDIPlus_RectFCreate(15, 20, 553, 500)		;Begrenzung
	$aInfo = _GDIPlus_GraphicsMeasureString($screen_context, $sString, $hFont, $tLayout, $hFormat)
	ConsoleWrite($aInfo[1])
	;Erstellt den Background:
	_GDIPlus_GraphicsDrawImage($screen_context, _GDIPlus_BitmapCloneArea($full, 0 , 0 , 583 , 16 , $GDIP_PXF32ARGB), 0, 0)
	_GDIPlus_GraphicsDrawImageRectRect ($screen_context, $full, 0 , 16 , 583 , 38 , 0, 16, 583, $aInfo[2]*20)
	_GDIPlus_GraphicsDrawImage($screen_context, _GDIPlus_BitmapCloneArea($full, 0 , 54 , 583 , 20, $GDIP_PXF32ARGB), 0, $aInfo[2]*20 + 16)
	
	;Erstellt den Text:
	_GDIPlus_GraphicsDrawStringEx($screen_context, $sString, $hFont, $tLayout, $hFormat, $hBrush)
	 
	;Erstellt das Gui mit der Meldung:
	$hwnd = GUICreate("Special-Message", 583, $aInfo[2]*20 + 36,-1,-1,-1,BitOR($WS_EX_LAYERED,$WS_EX_TOPMOST ))
	GUISetState()
	SetBitMap($hwnd,$screen, 255)
#EndRegion Main-Gui


#Region Stars
dim $gui[3][Random(10,15,1)]
for $i = 0 to UBound($gui,2)-1 step 1
	$gui[0][$i] = GUICreate("Alpha Blend", 140,140, Random(0,$VirtualDesktopWidth,1), Random(0,$VirtualDesktopHeight,1), -1, $WS_EX_LAYERED,$hwnd)
	$gui[1][$i] = Random(0,7,1)	;Picture
	$gui[2][$i] = Random(0,4,1)
	
	GUISetState()
Next
#EndRegion Stars




;Start Draw
AdlibRegister("Draw",120)
$timer = TimerInit()

do
Sleep(25)
until GUIGetMsg() = $GUI_EVENT_CLOSE or TimerDiff($timer) >= $sTime

for $i = 255 to 0 step -5
	$trans = $i
	SetBitMap($hwnd,$screen, $i)
	Sleep(20)
Next
_Exit()




func Draw()
	for $i = 0 to UBound($gui,2)-1 step 1
		SetBitMap($gui[0][$i], $bitmap[$gui[2][$i]][$gui[1][$i]], $trans)
		$gui[1][$i] = $gui[1][$i] + 1
		If $gui[1][$i] = 8 Then
			SetBitMap($gui[0][$i],"", $trans)
			$gui[1][$i] = 0
			$gui[2][$i] = Random(0,4,1)
			WinMove($gui[0][$i],"",Random(0,$VirtualDesktopWidth,1), Random(0,$VirtualDesktopHeight,1))

		endif
	Next
EndFunc

Func SetBitmap($hGUI, $hImage, $iOpacity)
  Local $hScrDC, $hMemDC, $hBitmap, $hOld, $pSize, $tSize, $pSource, $tSource, $pBlend, $tBlend

  $hScrDC  = _WinAPI_GetDC(0)
  $hMemDC  = _WinAPI_CreateCompatibleDC($hScrDC)
  $hBitmap = _GDIPlus_BitmapCreateHBITMAPFromBitmap($hImage)
  $hOld    = _WinAPI_SelectObject($hMemDC, $hBitmap)
  $tSize   = DllStructCreate($tagSIZE)
  $pSize   = DllStructGetPtr($tSize  )
  DllStructSetData($tSize, "X", _GDIPlus_ImageGetWidth ($hImage))
  DllStructSetData($tSize, "Y", _GDIPlus_ImageGetHeight($hImage))
  $tSource = DllStructCreate($tagPOINT)
  $pSource = DllStructGetPtr($tSource)
  $tBlend  = DllStructCreate($tagBLENDFUNCTION)
  $pBlend  = DllStructGetPtr($tBlend)
  DllStructSetData($tBlend, "Alpha" , $iOpacity    )
  DllStructSetData($tBlend, "Format", 1)
  _WinAPI_UpdateLayeredWindow($hGUI, $hScrDC, 0, $pSize, $hMemDC, $pSource, 0, $pBlend, $ULW_ALPHA)
  _WinAPI_ReleaseDC   (0, $hScrDC)
  _WinAPI_SelectObject($hMemDC, $hOld)
  _WinAPI_DeleteObject($hBitmap)
  _WinAPI_DeleteDC    ($hMemDC)
EndFunc

Func _ResourceLoadImage($DLL, $ResName)
    Local $hInstance, $InfoBlock, $GlobalMemoryBlock, $MemoryPointer, $ResSize, $hData, $pData, $pStream, $dll2, $pBitmap
    $hInstance = DllCall("kernel32.dll", "int", "LoadLibrary", "str", $DLL)
    $InfoBlock = DllCall("kernel32.dll", "int", "FindResourceA", "int", $hInstance[0], "str", $ResName, "long", 10)
    $ResSize = DllCall("kernel32.dll", "dword", "SizeofResource", "int", $hInstance[0], "int", $InfoBlock[0])
    $GlobalMemoryBlock = DllCall("kernel32.dll", "int", "LoadResource", "int", $hInstance[0], "int", $InfoBlock[0])
    $MemoryPointer = DllCall("kernel32.dll", "int", "LockResource", "int", $GlobalMemoryBlock[0])
    DllCall("Kernel32.dll", "int", "FreeLibrary", "str", $hInstance[0])
    $hData = _MemGlobalAlloc($ResSize[0], 2)
    $pData = _MemGlobalLock($hData)
    _MemMoveMemory($MemoryPointer[0], $pData, $ResSize[0])
    _MemGlobalUnlock($hData)
    $pStream = DllCall("ole32.dll", "int", "CreateStreamOnHGlobal", "int", $hData, "long", 1, "Int*", 0)
	
    $pBitmap = DllCall($ghGDIPDll, "int", "GdipCreateBitmapFromStream", "ptr", $pStream[3], "int*", 0)
    $DLL = DllStructCreate("Uint", $pStream[3])
    $dll2 = DllStructCreate("uInt", DllStructGetData($DLL, 1) + 8)
    DllCall("", "UInt", DllStructGetData($dll2, 1), "UInt", $pStream[3])
    _WinAPI_DeleteObject($pStream[3])
    $pStream[3] = 0
    _MemGlobalFree($hData)
    Return $pBitmap[2]
EndFunc   

func _Exit()
	_GDIPlus_FontDispose($hFont)
    _GDIPlus_FontFamilyDispose($hFamily)
    _GDIPlus_StringFormatDispose($hFormat)
    _GDIPlus_BrushDispose($hBrush)
    _GDIPlus_GraphicsDispose($screen_context)
	for $i = 0 to 4 step 1
		for $l = 0 to 7 step 1
			_GDIPlus_ImageDispose ($bitmap[$i][$l] )
		Next
	Next
	_GDIPlus_ImageDispose ($full)
	_GDIPlus_ImageDispose ($screen)
    _GDIPlus_Shutdown()

	FileDelete ( @TempDir & "\gfx.dll" )
EndFunc